size=10
start={41,0}
background="gfx/gray.png"

addhook("always","_always")
addhook("clientdata","_clientdata")

ratio=0.03125
mouse={}
images={}

for i=1,32 do
	images[i]={}
end

function _always()
	reqcld(0,2)
	for _,id in pairs(player(0,"table")) do
		if #images[id]>0 and #getImages(id)==0 then
			for _,id2 in pairs(images[id]) do
				freeimage(id2)
			end
			images[id]={}
		elseif #getImages(id)~=0 and #images[id]==0 then
			for _,id2 in pairs(getImages(id)) do
				table.insert(images[id],image("<tile:"..id2[1]..">",(start[1]+id2[2])*size,(start[2]+id2[3])*size,2,id))
				if id2[4] then
					imagecolor(images[id][#images[id]],255,0,0)
				end
				imagescale(images[id][#images[id]],ratio*size,ratio*size)
			end
			for _,id2 in pairs(player(0,"tableliving")) do
				table.insert(images[id],image(background,(start[1]+player(id2,"x")/32)*size,(start[2]+player(id2,"y")/32)*size,2,id))
				imagecolor(images[id][#images[id]],255,0,0)
			end
			table.insert(images[id],image(background,525,115,2,id))
			imagescale(images[id][#images[id]],7,7)
		end
	end
end

function getImages(id)
	local images={}
	for _2,id2 in pairs(object(0,"table")) do
		if object(id2,"type")==13 and object(id2,"team")==player(id,"team") and math.floor(mouse[id][1]/32)==object(id2,"tilex") and math.floor(mouse[id][2]/32)==object(id2,"tiley") then
			for _3,id3 in pairs(object(0,"table")) do
				if object(id3,"type")==14 and object(id3,"player")==object(id2,"player") then
					local delimit={object(id3,"tilex")-11,object(id3,"tiley")-11}
					for x=object(id3,"tilex")-10,object(id3,"tilex")+10 do
						for y=object(id3,"tiley")-10,object(id3,"tiley")+10 do
							local center=false
							if x==object(id3,"tilex") and y==object(id3,"tiley") then
								center=true
							end
							table.insert(images,{tile(x,y,"frame"),x-delimit[1],y-delimit[2],center})
						end
					end
				end
			end
		end
	end
	return images
end

function _clientdata(id,mode,data1,data2)
	if mode==2 then
		mouse[id]={data1,data2}
	end
end